library IBCover;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  DB,
  IBCustomDataSet,
  IBQuery,
  IBDatabase,
  IBScript,
  IniFiles,
  Dialogs;

{$R *.res}
const NUMBS=11; //      
var
    DBase: array[0..NUMBS] of TIBDatabase;
    TR: array[0..NUMBS] of TIBTransaction;
    Q: array[0..NUMBS] of TIBQuery;
    S: array[0..NUMBS] of TIBScript;
    Str: array[0..NUMBS] of string;
    fSelect: array[0..NUMBS] of Boolean;

//   
function GetIndex(tag:Integer): Integer;
var i:Integer;
begin
  Result:=-1;
  for i:=0 to 10 do
    if Assigned(DBase[i]) then
    if (DBase[i].Tag=tag) then begin
      Result:=i;
      break;
    end;
end;

//  ,   <1    
function Initial(tag: Integer; sq: PChar): Integer stdcall;
var ini: TIniFile;
    ind: Integer;
    sql: string;
begin
Result := 1;
ind:=GetIndex(tag);
if (ind < 0) then begin
for ind:=0 to 10 do
if not Assigned(DBase[ind]) then begin
    DBase[ind] := TIBDatabase.Create(nil);
  if not Assigned(TR[ind]) then
    TR[ind] := TIBTransaction.Create(DBase[ind]);
  if not Assigned(Q[ind]) then
    Q[ind] := TIBQuery.Create(DBase[ind]);
  if not Assigned(S[ind]) then
    S[ind] := TIBScript.Create(DBase[ind]);

  DBase[ind].Tag := tag;
  TR[ind].Tag := tag;
  Q[ind].Tag := tag;
  S[ind].Tag := tag;

  if not DBase[ind].Connected then
  try
    DBase[ind].LoginPrompt := False;
    DBase[ind].DefaultTransaction := TR[ind];
    TR[ind].DefaultDatabase := DBase[ind];
    Q[ind].Database := DBase[ind];
    Q[ind].Transaction := TR[ind];
    S[ind].Database := DBase[ind];
    S[ind].Transaction := TR[ind];

    DBase[ind].Params.Clear;
    DBase[ind].Params.Add('lc_ctype=WIN1251');
    DBase[ind].Params.Add('user_name=SYSDBA');
    DBase[ind].Params.Add('password=masterkey');

    DBase[ind].DatabaseName := trim(sq);
    if DBase[ind].DatabaseName='' then begin
      Ini := TIniFile.Create('DATSEVENT.INI');
      DBase[ind].DatabaseName := Ini.ReadString('PATH', 'DATABASE', '');
    end;
    if (DBase[ind].DatabaseName = '') then
    begin
      DBase[ind].DatabaseName := InputBox('    ', '   ', '');
      while (not FileExists(DBase[ind].DatabaseName)) and (DBase[ind].DatabaseName <> '') do
        DBase[ind].DatabaseName := InputBox('    ', '   ', '');
      if (DBase[ind].DatabaseName <> '') then begin
        Ini.WriteString('PATH', 'DATABASE', DBase[ind].DatabaseName)
      end;
    end;
    Ini.Free;
    if (DBase[ind].DatabaseName <> '') then
      try
        DBase[ind].Connected := True;
      except
        Result := -2;
      end else Result := -3;
  except
    DBase[ind].Destroy;
    Result := -1;
  end;
  break;
end;
end else begin
  Result:=ind;
  exit;
end;
ind:=GetIndex(tag);
if (ind<0) and (Result>=0) then Result:=-4
else Result:=ind;
end;
//
function Finaliz(tag: integer): Integer stdcall;
var i: Integer;
begin
i:=GetIndex(tag);
if (i>=0) then begin
  if (DBase[i].Connected) then
    DBase[i].Connected := False;
  if Assigned(S[i]) then S[i].Destroy;
  if Assigned(Q[i]) then Q[i].Destroy;
  if Assigned(TR[i]) then TR[i].Destroy;
  if Assigned(DBase[i]) then DBase[i].Destroy;
  S[i]:=nil;
  Q[i]:=nil;
  TR[i]:=nil;
  DBase[i]:=nil;
end;
end;

//   select update delete insert,
//   select      ";"
//   update delete insert  "1"
// ,  
function ExecSQL(tag:Integer; sq: PChar): PChar stdcall;
var i, ind: Integer;
  sql: string;
begin
  sql := trim(sq);
  Result := nil;
ind:=Initial(Tag, '');
if (ind>=0) then begin
  fSelect[ind] := False;
  if (trim(sql) = '') then exit;
  if    (Pos('select', sql)<>1)
    and (Pos('update', sql)<>1)
    and (Pos('delete', sql)<>1)
    and (Pos('insert', sql)<>1)
  then exit;

  if (ind >= 0) then try
    if Q[ind].Active then Q[ind].Close;
    Q[ind].SQL.Text := sql;
    if (Pos('select', trim(sql))=1)
    then begin
      Q[ind].Open;
      Q[ind].First;
      fSelect[ind] := True;
      if Q[ind].Eof then
        Str[ind] := 'EOF'
      else begin
        Str[ind] := '';
        for i:=0 to Q[ind].FieldCount-1 do begin
          Str[ind] := Str[ind] + Q[ind].Fields[i].AsString + ';';
        end;
      end
    end else begin
      if not Q[ind].Transaction.Active then Q[ind].Transaction.StartTransaction;
      Q[ind].ExecSQL;
      Q[ind].Transaction.Commit;
      Str[ind] := '1';
    end;
    Result := PChar(Str[ind]);
  except
    on E: Exception do begin
      Str[ind] := E.Message + ' ('+sql + ')';
      Result := PChar(Str[ind]);
    end
  end
end;
end;

//      step-
//        ";"
//   EOF  BOF
//   <1
function MoveTo(tag, step: integer): PChar stdcall;
var i, ind: Integer;
begin
  ind:=GetIndex(tag);
  Str[ind] := '1';
  Result := nil;
  if ind<0 then
    Str[ind] := '-3'
  else
  if (not Q[ind].Active) then
    Str[ind] := '-1'
  else if (not fSelect[ind]) then
    Str[ind] := '-2'
  else if (step=0) then
    Str[ind] := '0';
  if (Str[ind]<>'1') then begin
    Result := PChar(Str[ind]);
    exit;
  end;

  while (Step>0) and (not Q[ind].Eof) do begin
    Q[ind].Next;
    step := step-1;
  end;
  while (Step<0) and (not Q[ind].Bof) do begin
    Q[ind].Prior;
    step := step+1;
  end;

  if Q[ind].Eof then Str[ind] := 'EOF'
  else
  if Q[ind].Bof then Str[ind] := 'BOF'
  else begin
    Str[ind] := '';
    for i:=0 to Q[ind].FieldCount-1 do
      Str[ind] := Str[ind] + Q[ind].Fields[i].AsString + ';';
  end;
  Result := PChar(Str[ind]);
end;

//        
//        ";"
//   <1
function FieldByName(tag: Integer; name: PChar): PChar stdcall;
var ind: Integer;
begin
  ind:=GetIndex(tag);
  Str[ind] := '1';
  Result := nil;
  if ind<0 then
    Str[ind] := '-3'
  else
  if (not Q[ind].Active) then
    Str[ind] := '-1'
  else if (not fSelect[ind]) then
    Str[ind] := '-2'
  else if not Assigned(Q[ind].FindField(name)) then
    Str[ind] := '-3';
  if (Str[ind]<>'1') then begin
    Result := PChar(Str[ind]);
    exit;
  end;

  Str[ind] := Q[ind].FieldByName(name).AsString+';';
  Result := PChar(Str[ind]);
end;

// 
//    1
//   <1
function ExecuteScript(tag: Integer; sq: PChar): PChar  stdcall;
var ind: Integer;
    sql: string;
begin
  sql := sq;
  Result := nil;
  if (trim(sql) = '') then exit;
  ind:=Initial(tag, '');
  if (ind >= 0) then try
    S[ind].Script.Clear;
    S[ind].Script.Add(sql);
    if not S[ind].Transaction.Active then
      S[ind].Transaction.StartTransaction;
    S[ind].ExecuteScript;
    Str[ind] := '1';
    Result := PChar(Str[ind]);
  except
    on E: Exception do begin
      Str[ind] := E.Message + ' ('+sql + ')';
      Result := PChar(Str[ind]);
    end
  end
end;

function ExecuteFile(tag: Integer; sq: PChar): PChar  stdcall;
var ind: Integer;
    sql: string;
    ini: TIniFile;
begin
ind:=GetIndex(tag);
sql := sq;
  Result := nil;
  Ini := TIniFile.Create('DATSEVENT.INI');
  sql := Ini.ReadString('PATH', 'DIRFILES', '') + sql;
  Ini.Free;
  if not FileExists(sql) then begin
    Str[ind] := '      ';
    Result := PChar(Str[ind]);
    exit;
  end;
  if (trim(sql) = '') then exit;
  if (Initial(tag, '') <> -1) then try
    S[ind].Script.Clear;
    S[ind].Script.LoadFromFile(sql);
    if not S[ind].Transaction.Active then
      S[ind].Transaction.StartTransaction;
    S[ind].ExecuteScript;
    Str[ind] := '1';
    Result := PChar(Str[ind]);
  except
    on E: Exception do begin
      Str[ind] := E.Message + ' ('+sql + ')';
      Result := PChar(Str[ind]);
    end
  end
end;


exports Initial;
exports Finaliz;
exports ExecSQL;
exports MoveTo;
exports ExecuteScript;
exports ExecuteFile;
exports FieldByName;

begin
end.
